#ifndef _AisaR08_H_
#define _AisaR08_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AISA08_MAX_SLOTS 	16
#define	AISA08_SLOT_AUTO	((WORD) ~0U)
#define	AISA08_PORT_0		0
#define	AISA08_PORT_1		1
#define	AISA08_PORT_2		2

// G[R[h
#define AISA08_SUCCESS				0	// ُȂ
#define AISA08_ERR_SYSTEM			1	// GetLastError sĂ
#define AISA08_ERR_NO_DEVICE		2	// gp\ȃfoCXȂ
#define AISA08_ERR_IN_USE			3	// w肳ꂽXbg͎gp
#define AISA08_ERR_INVALID_SLOT		4	// Ș_Xbgԍ
#define AISA08_ERR_RESOURCE			5	// \[XG[
#define AISA08_ERR_INVALID_PORT		6	// ȃ|[gԍ
#define AISA08_ERR_INVALID_ARGUMENT	7	// Ȉ

#define AISA08_MAX_MEM		9
#define AISA08_MAX_IO		20
#define AISA08_MAX_IRQ		7
#define AISA08_MAX_DMA		7

//======================================================================
// \[X\
//======================================================================
typedef struct {
	DWORD	dwNumMemWindows;                   // EChE	gp
	DWORD	dwMemBase		[AISA08_MAX_MEM];  // MWx[XAhX		gp
	DWORD	dwMemLength		[AISA08_MAX_MEM];  // MW					gp
	DWORD	dwMemAttrib		[AISA08_MAX_MEM];  // MW				gp
	DWORD	dwNumIOPorts;                      // I/O|[g
	DWORD	dwIOPortBase	[AISA08_MAX_IO];   // I/O|[gx[XAhX
	DWORD	dwIOPortLength	[AISA08_MAX_IO];   // I/O|[g
	DWORD	dwNumIRQs;                         // IRQ					gp
	DWORD	dwIRQRegisters	[AISA08_MAX_IRQ];  // IRQXg				gp
	DWORD	dwIRQAttrib		[AISA08_MAX_IRQ];  // IRQXg			gp
	DWORD	dwNumDMAs;                         // DMA`l			gp
	DWORD	dwDMALst		[AISA08_MAX_DMA];  // DMA`lXg		gp
	DWORD	dwDMAAttrib		[AISA08_MAX_DMA];  // DMA`lXg	gp
	DWORD	dwReserved1		[3];               // \					gp
} AISA08RESOURCE;

typedef		AISA08RESOURCE *PAISA08R;
typedef		AISA08RESOURCE FAR *LPAISA08R;

//-- ȉAPI --
//======================================================================
// VxD  DLL ̃o[W擾
//======================================================================
BOOL WINAPI Aisa08GetVersion(
	PDWORD		pdwDllVer,		// VxD Version
	PDWORD		pdwVxDVer );	// DLL Version
	
//======================================================================
// foCXgp錾
//======================================================================
BOOL WINAPI Aisa08Create(
	PWORD pwLogSlot );			// Xbgԍ( 0`15 or SLOT_AUTO )
	
//======================================================================
// foCXJ
//======================================================================
BOOL WINAPI Aisa08Close(
	WORD wLogSlot );			// Xbgԍ( 0`15 )
	
//======================================================================
// \[X擾
//======================================================================
BOOL WINAPI Aisa08GetResource(
	WORD	wLogSlot,			// Slot
	AISA08RESOURCE *pRes );		// \[X\̂̃|C^
	

//======================================================================
// AEg|[g
//======================================================================
BOOL WINAPI Aisa08OutPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 2 )
	BYTE	bValue );			// l
	
//======================================================================
// Ōw肳ꂽXbgŔsꂽG[R[ho
//======================================================================
DWORD WINAPI Aisa08GetLastError(
	WORD	wLogSlot );			// Slot

#ifdef __cplusplus
}
#endif
#endif
